<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2009 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_1/classes/prom_race.php $
 * $Id: prom_race.php 1361 2009-01-02 21:58:34Z quietust $
 */

if (!defined('IN_GAME') && !defined('IN_TURNS'))
	die("Access denied");

require_once(PROM_BASEDIR .'classes/prom_static.php');

define('RACE_HUMAN', 1);
define('RACE_ELF', 2);
define('RACE_DWARF', 3);
define('RACE_TROLL', 4);
define('RACE_GNOME', 5);
define('RACE_GREMLIN', 6);
define('RACE_ORC', 7);
define('RACE_DROW', 8);
define('RACE_GOBLIN', 9);

class prom_race extends prom_static
{
	protected static $races = array(
		RACE_HUMAN => array(
			'name'		=> 'RACE_HUMAN',
			'offense'	=> 1.00,
			'defense'	=> 1.00,
			'buildrate'	=> 1.00,
			'expenses'	=> 1.00,
			'magic'		=> 1.00,
			'industry'	=> 1.00,
			'income'	=> 1.00,
			'explore'	=> 1.00,
			'market'	=> 1.00,
			'foodcon'	=> 1.00,
			'runepro'	=> 1.00,
			'foodpro'	=> 1.00),
		RACE_ELF => array(
			'name'		=> 'RACE_ELF',
			'offense'	=> 0.86,
			'defense'	=> 0.98,
			'buildrate'	=> 0.90,
			'expenses'	=> 1.00,
			'magic'		=> 1.18,
			'industry'	=> 0.88,
			'income'	=> 1.02,
			'explore'	=> 1.12,
			'market'	=> 1.00,
			'foodcon'	=> 1.00,
			'runepro'	=> 1.12,
			'foodpro'	=> 0.94),
		RACE_DWARF => array(
			'name'		=> 'RACE_DWARF',
			'offense'	=> 1.06,
			'defense'	=> 1.16,
			'buildrate'	=> 1.16,
			'expenses'	=> 1.08,
			'magic'		=> 0.84,
			'industry'	=> 1.12,
			'income'	=> 1.00,
			'explore'	=> 0.82,
			'market'	=> 1.08,
			'foodcon'	=> 1.00,
			'runepro'	=> 1.00,
			'foodpro'	=> 1.00),
		RACE_TROLL => array(
			'name'		=> 'RACE_TROLL',
			'offense'	=> 1.24,
			'defense'	=> 0.90,
			'buildrate'	=> 1.08,
			'expenses'	=> 1.00,
			'magic'		=> 0.88,
			'industry'	=> 1.00,
			'income'	=> 1.04,
			'explore'	=> 1.14,
			'market'	=> 1.12,
			'foodcon'	=> 1.00,
			'runepro'	=> 0.92,
			'foodpro'	=> 0.92),
		RACE_GNOME => array(
			'name'		=> 'RACE_GNOME',
			'offense'	=> 0.84,
			'defense'	=> 1.10,
			'buildrate'	=> 1.00,
			'expenses'	=> 0.94,
			'magic'		=> 1.00,
			'industry'	=> 0.90,
			'income'	=> 1.10,
			'explore'	=> 0.88,
			'market'	=> 0.76,
			'foodcon'	=> 1.00,
			'runepro'	=> 0.88,
			'foodpro'	=> 1.00),
		RACE_GREMLIN => array(
			'name'		=> 'RACE_GREMLIN',
			'offense'	=> 1.10,
			'defense'	=> 0.94,
			'buildrate'	=> 1.00,
			'expenses'	=> 1.00,
			'magic'		=> 0.90,
			'industry'	=> 0.86,
			'income'	=> 0.80,
			'explore'	=> 1.00,
			'market'	=> 0.92,
			'foodcon'	=> 0.86,
			'runepro'	=> 1.00,
			'foodpro'	=> 1.18),
		RACE_ORC => array(
			'name'		=> 'RACE_ORC',
			'offense'	=> 1.16,
			'defense'	=> 1.00,
			'buildrate'	=> 1.04,
			'expenses'	=> 1.14,
			'magic'		=> 0.96,
			'industry'	=> 1.08,
			'income'	=> 1.00,
			'explore'	=> 1.22,
			'market'	=> 1.00,
			'foodcon'	=> 1.10,
			'runepro'	=> 0.86,
			'foodpro'	=> 0.92),
		RACE_DROW => array(
			'name'		=> 'RACE_DROW',
			'offense'	=> 1.14,
			'defense'	=> 1.06,
			'buildrate'	=> 0.88,
			'expenses'	=> 1.10,
			'magic'		=> 1.18,
			'industry'	=> 1.00,
			'income'	=> 1.00,
			'explore'	=> 0.84,
			'market'	=> 1.00,
			'foodcon'	=> 1.00,
			'runepro'	=> 1.06,
			'foodpro'	=> 0.94),
		RACE_GOBLIN => array(
			'name'		=> 'RACE_GOBLIN',
			'offense'	=> 0.82,
			'defense'	=> 0.84,
			'buildrate'	=> 1.00,
			'expenses'	=> 0.82,
			'magic'		=> 1.00,
			'industry'	=> 1.14,
			'income'	=> 1.00,
			'explore'	=> 1.00,
			'market'	=> 1.06,
			'foodcon'	=> 0.92,
			'runepro'	=> 1.00,
			'foodpro'	=> 1.00),
	);

	// Loads variables
	public function load ()
	{
		if (!self::exists($this->id))
		{
			warning('Entity '. $this->id .' of type '. get_class($this) .' failed to locate data', 1);
			return FALSE;
		}

		$this->data = self::$races[$this->id];
		return TRUE;
	}

	// By default, retrieve race's name
	public function __toString ()
	{
		if ($this->id == 0)
			return lang('RACE_UNKNOWN');
		return lang($this->name);
	}

	public static function exists ($id)
	{
		return isset(self::$races[$id]);
	}

	// Loads all race names into an associative array keyed by race ID
	public static function getNames ()
	{
		$names = array();
		foreach (self::$races as $id => $race)
			$names[$id] = lang($race['name']);
		return $names;
	}

	// Provided mainly for round history, which needs to resolve and cache only the race names
	public static function lookup ($race, $data)
	{
		if (!self::exists($race))
			return;
		if (!isset(self::$races[$race][$data]))
			return;
		return self::$races[$race][$data];
	}
} // class prom_race
?>
