<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2009 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_1/pages/admin/log.php $
 * $Id: log.php 1467 2009-03-03 18:03:27Z quietust $
 */

if (!defined('IN_GAME'))
	die("Access denied");

$title = 'ADMIN_LOG_TITLE';

$needpriv = UFLAG_ADMIN;

require(PROM_BASEDIR .'includes/header.php');

// For compatibility with versions of PHP prior to 5.2, the constants E_RECOVERABLE_ERROR and E_DEPRECATED are not used below
// Since E_ERROR cannot be handled using the log handler, it is reused for empires flaged with EFLAG_LOGGED
$loglevels = array(
	0 => lang('ADMIN_LOG_LEVEL_EVENT'),
	E_ERROR => lang('ADMIN_LOG_LEVEL_LOGEVENT'),
	E_WARNING => lang('ADMIN_LOG_LEVEL_WARNING'),
	E_NOTICE => lang('ADMIN_LOG_LEVEL_NOTICE'),
	E_USER_ERROR => lang('ADMIN_LOG_LEVEL_CERROR'),
	E_USER_WARNING => lang('ADMIN_LOG_LEVEL_CWARNING'),
	E_USER_NOTICE => lang('ADMIN_LOG_LEVEL_CNOTICE'),
	E_STRICT => lang('ADMIN_LOG_LEVEL_STRICT'),
	4096 => lang('ADMIN_LOG_LEVEL_RECOVER'),
	8192 => lang('ADMIN_LOG_LEVEL_DEPRECATED'),
);

if ($action == 'delete')
{
	$id = fixInputNum(getFormVar('log_last'));
	$q = $db->prepare('DELETE FROM '. LOG_TABLE .' WHERE log_id <= ?');
	db_bindIntValue($q, 1, $id);
	if ($q->execute())
		notice(lang('ADMIN_LOG_DELETE_SUCCESS'));
	else	notice(lang('ADMIN_LOG_DELETE_FAIL'));
	logevent();
}
notices();

$sortcol = getFormVar('sortcol', 'time');
$sortdir = getFormVar('sortdir', 'desc');
if ($sortdir == 'asc')
	$dir = ' ASC';
else	$dir = ' DESC';
switch ($sortcol)
{
	default:
		$sortcol = 'time';
	case 'time':
		$sortby = 'log_time';
		break;
	case 'type':
		$sortby = 'log_type';
		break;
	case 'ip':
		$sortby = 'log_ip';
		break;
	case 'page':
		$sortby = 'log_page';
		break;
	case 'action':
		$sortby = 'log_action';
		break;
	case 'locks':
		$sortby = 'log_locks';
		break;
}
$last = sqleval($db, 'SELECT MAX(log_id) FROM '. LOG_TABLE);
$total = sqleval($db, 'SELECT COUNT(*) FROM '. LOG_TABLE);
$page = fixInputNum(getFormVar('page'));
$per = 100;	// 100 rows per page
$offset = ($page - 1) * $per;
if ($offset > $total)
{
	$page = ceil($total / $per);
	$offset = ($page - 1) * $per;
}
if ($offset < 0)
{
	$page = 1;
	$offset = 0;
}
$sortlink = '?location=admin/log&amp;';

$sql = 'SELECT * FROM '. LOG_TABLE .' ORDER BY '. $sortby . $dir .', log_id DESC';
$sql = db_setLimit($db, $sql, $per, $offset);
$q = $db->query($sql) or warning('Failed to fetch log entries', 0);

$logs = $q->fetchAll();
?>
<table class="inputtable">
<tr><th><?=sortlink(lang('ADMIN_LOG_COLUMN_DATE'), $sortlink, $sortcol, $sortdir, 'time', 'desc', $page)?></th>
    <th><?=sortlink(lang('ADMIN_LOG_COLUMN_TYPE'), $sortlink, $sortcol, $sortdir, 'type', 'asc', $page)?></th>
    <th><?=sortlink(lang('ADMIN_LOG_COLUMN_IPADDR'), $sortlink, $sortcol, $sortdir, 'ip', 'asc', $page)?></th>
    <th><?=sortlink(lang('ADMIN_LOG_COLUMN_PAGE'), $sortlink, $sortcol, $sortdir, 'page', 'asc', $page)?></th>
    <th><?=sortlink(lang('ADMIN_LOG_COLUMN_ACTION'), $sortlink, $sortcol, $sortdir, 'action', 'asc', $page)?></th>
    <th><?=sortlink(lang('ADMIN_LOG_COLUMN_LOCKS'), $sortlink, $sortcol, $sortdir, 'locks', 'asc', $page)?></th>
    <th><?=lang('ADMIN_LOG_COLUMN_DATA')?></th></tr>
<?
foreach ($logs as $log)
{
?>
<tr><td><?=$user1->date('r', $log['log_time'])?></td>
    <td><?if (isset($loglevels[$log['log_type']])) echo $loglevels[$log['log_type']]; else echo lang('ADMIN_LOG_LEVEL_UNKNOWN');?></td>
    <td><?=$log['log_ip']?></td>
    <td><?=htmlspecialchars($log['log_page'])?></td>
    <td><?=htmlspecialchars($log['log_action'])?></td>
    <td><?=htmlspecialchars($log['log_locks'])?></td>
    <td><?=htmlspecialchars($log['log_text'])?></td></tr>
<?
}
$pages = ceil($total / $per);
if ($pages > 0)
{
?>
<tr><td colspan="7" class="ar"><?=pagelist($page, $pages, $sortlink, $sortcol, $sortdir)?><br />
<form method="post" action="?location=admin/log">
<div>
<input type="hidden" name="action" value="delete" />
<input type="hidden" name="log_last" value="<?=$last?>" />
<input type="submit" value="<?=lang('ADMIN_LOG_SUBMIT')?>" />
</div>
</form>
</td></tr>
<?
}
else	echo '<tr><td colspan="7" class="ac">'. lang('ADMIN_LOG_NO_DATA') .'</td></tr>';
?>
</table>
<?
require(PROM_BASEDIR .'includes/footer.php');
?>
